Upstream information

CVE-2019-3822 at MITRE

Description

libcurl versions from 7.36.0 to before 7.64.0 are vulnerable to a stack-based buffer overflow. The function creating an outgoing NTLM type-3 header (`lib/vauth/ntlm.c:Curl_auth_create_ntlm_type3_message()`), generates the request HTTP header contents based on previously received data. The check that exists to prevent the local buffer from getting overflowed is implemented wrongly (using unsigned math) and as such it does not prevent the overflow from happening. This output data can grow larger than the local buffer if very large 'nt response' data is extracted from a previous NTLMv2 header provided by the malicious or broken HTTP server. Such a 'large value' needs to be around 1000 bytes or more. The actual payload data copied to the target buffer comes from the NTLMv2 type-2 response header.

SUSE information

Overall state of this security issue: Resolved

This issue is currently rated as having important severity.

CVSS v2 Scores
  National Vulnerability Database
Base Score 7.5
Vector AV:N/AC:L/Au:N/C:P/I:P/A:P
Access Vector Network
Access Complexity Low
Authentication None
Confidentiality Impact Partial
Integrity Impact Partial
Availability Impact Partial
CVSS v3 Scores
  National Vulnerability Database SUSE
Base Score 9.8 7.5
Vector AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H
Access Vector Network Network
Access Complexity Low High
Privileges Required None None
User Interaction None Required
Scope Unchanged Unchanged
Confidentiality Impact High High
Integrity Impact High High
Availability Impact High High
SUSE Bugzilla entries: 1123377 [RESOLVED / FIXED], 1141798 [IN_PROGRESS]

SUSE Security Advisories:

List of released packages

Product(s) Fixed package version(s) References
Openstack Cloud Magnum Orchestration 7
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
Patchnames:
SUSE-OpenStack-Cloud-Magnum-Orchestration-7-2019-249
SUSE CaaS Platform 3.0
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
Patchnames:
SUSE-CAASP-3.0-2019-249
SUSE CaaS Platform ALL
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
Patchnames:
SUSE-CAASP-ALL-2019-249
SUSE Enterprise Storage 4
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-Storage-4-2019-249
SUSE Linux Enterprise Desktop 12 SP3
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-DESKTOP-12-SP3-2019-249
SUSE Linux Enterprise Desktop 12 SP4
  • curl >= 7.60.0-4.3.1
  • libcurl4 >= 7.60.0-4.3.1
  • libcurl4-32bit >= 7.60.0-4.3.1
Patchnames:
SUSE-SLE-DESKTOP-12-SP4-2019-339
SUSE Linux Enterprise Module for Basesystem 15
  • curl >= 7.60.0-3.17.1
  • libcurl-devel >= 7.60.0-3.17.1
  • libcurl4 >= 7.60.0-3.17.1
  • libcurl4-32bit >= 7.60.0-3.17.1
Patchnames:
SUSE-SLE-Module-Basesystem-15-2019-248
SUSE Linux Enterprise Module for Basesystem 15 SP1
  • curl >= 7.60.0-3.17.1
  • libcurl-devel >= 7.60.0-3.17.1
  • libcurl4 >= 7.60.0-3.17.1
  • libcurl4-32bit >= 7.60.0-3.17.1
Patchnames:
SUSE Linux Enterprise Module for Basesystem 15 SP1 GA curl
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15
  • curl-mini >= 7.60.0-3.17.1
  • libcurl-mini-devel >= 7.60.0-3.17.1
  • libcurl4-mini >= 7.60.0-3.17.1
Patchnames:
SUSE-SLE-Module-Development-Tools-OBS-15-2019-248
SUSE Linux Enterprise Point of Sale 12 SP2-CLIENT
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-POS-12-SP2-CLIENT-2019-249
SUSE Linux Enterprise Server 12 SP1-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP1-2019-249
SUSE Linux Enterprise Server 12 SP2-BCL
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-BCL-2019-249
SUSE Linux Enterprise Server 12 SP2-ESPOS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-ESPOS-2019-249
SUSE Linux Enterprise Server 12 SP2-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-2019-249
SUSE Linux Enterprise Server 12 SP3
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP3-2019-249
SUSE Linux Enterprise Server 12 SP4
  • curl >= 7.60.0-4.3.1
  • libcurl4 >= 7.60.0-4.3.1
  • libcurl4-32bit >= 7.60.0-4.3.1
Patchnames:
SUSE-SLE-SERVER-12-SP4-2019-339
SUSE Linux Enterprise Server 12-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP1
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SAP-12-SP1-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP1-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP1-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP2
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SAP-12-SP2-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP2-BCL
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-BCL-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP2-ESPOS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-ESPOS-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP2-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP2-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP3
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-SP3-2019-249
SUSE Linux Enterprise Server for SAP Applications 12 SP4
  • curl >= 7.60.0-4.3.1
  • libcurl4 >= 7.60.0-4.3.1
  • libcurl4-32bit >= 7.60.0-4.3.1
Patchnames:
SUSE-SLE-SERVER-12-SP4-2019-339
SUSE Linux Enterprise Server for SAP Applications 12-LTSS
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SERVER-12-2019-249
SUSE Linux Enterprise Software Development Kit 12 SP3
  • curl >= 7.37.0-37.34.1
  • libcurl-devel >= 7.37.0-37.34.1
Patchnames:
SUSE-SLE-SDK-12-SP3-2019-249
SUSE Linux Enterprise Software Development Kit 12 SP4
  • curl >= 7.60.0-4.3.1
  • libcurl-devel >= 7.60.0-4.3.1
Patchnames:
SUSE-SLE-SDK-12-SP4-2019-339
SUSE OpenStack Cloud 7
  • curl >= 7.37.0-37.34.1
  • libcurl4 >= 7.37.0-37.34.1
  • libcurl4-32bit >= 7.37.0-37.34.1
Patchnames:
SUSE-OpenStack-Cloud-7-2019-249
openSUSE Leap 15.0
  • curl >= 7.60.0-lp150.2.18.1
  • curl-debuginfo >= 7.60.0-lp150.2.18.1
  • curl-debugsource >= 7.60.0-lp150.2.18.1
  • curl-mini >= 7.60.0-lp150.2.18.1
  • curl-mini-debuginfo >= 7.60.0-lp150.2.18.1
  • curl-mini-debugsource >= 7.60.0-lp150.2.18.1
  • libcurl-devel >= 7.60.0-lp150.2.18.1
  • libcurl-devel-32bit >= 7.60.0-lp150.2.18.1
  • libcurl-mini-devel >= 7.60.0-lp150.2.18.1
  • libcurl4 >= 7.60.0-lp150.2.18.1
  • libcurl4-32bit >= 7.60.0-lp150.2.18.1
  • libcurl4-32bit-debuginfo >= 7.60.0-lp150.2.18.1
  • libcurl4-debuginfo >= 7.60.0-lp150.2.18.1
  • libcurl4-mini >= 7.60.0-lp150.2.18.1
  • libcurl4-mini-debuginfo >= 7.60.0-lp150.2.18.1
Patchnames:
openSUSE-2019-174
openSUSE Leap 42.3
  • curl >= 7.37.0-45.1
  • curl-debuginfo >= 7.37.0-45.1
  • curl-debugsource >= 7.37.0-45.1
  • libcurl-devel >= 7.37.0-45.1
  • libcurl-devel-32bit >= 7.37.0-45.1
  • libcurl4 >= 7.37.0-45.1
  • libcurl4-32bit >= 7.37.0-45.1
  • libcurl4-debuginfo >= 7.37.0-45.1
  • libcurl4-debuginfo-32bit >= 7.37.0-45.1
Patchnames:
openSUSE-2019-173


Status of this issue by product and package

Please note that this evaluation state might be work in progress, incomplete or outdated. Also information for service packs in the LTSS phase is only included for issues meeting the LTSS criteria. If in doubt, feel free to contact us for clarification.

Product(s) Source package State
CaaS Platform 2.0 curl Released
CaaS Platform 3.0 curl Released
OpenStack Cloud Magnum Orchestration 7.0 curl Released
SUSE Linux Enterprise Desktop 12 SP3 curl Released
SUSE Linux Enterprise Desktop 12 SP4 curl Released
SUSE Linux Enterprise High Performance Computing 12 curl Released
SUSE Linux Enterprise Module for Basesystem 15 GA curl Released
SUSE Linux Enterprise SDK 11 SP4 curl Not affected
SUSE Linux Enterprise SDK 12 SP3 curl Released
SUSE Linux Enterprise SDK 12 SP4 curl Released
SUSE Linux Enterprise Server 11 SP3 LTSS curl Not affected
SUSE Linux Enterprise Server 11 SP4 curl Not affected
SUSE Linux Enterprise Server 12 GA LTSS curl Released
SUSE Linux Enterprise Server 12 SP1 LTSS curl Released
SUSE Linux Enterprise Server 12 SP2 LTSS curl Released
SUSE Linux Enterprise Server 12 SP3 curl Released
SUSE Linux Enterprise Server 12 SP4 curl Released
SUSE Linux Enterprise Server for SAP Applications 11 SP3 curl Not affected
SUSE Linux Enterprise Server for SAP Applications 12 GA curl Affected
SUSE Linux Enterprise Server for SAP Applications 12 SP2 curl Released
SUSE Linux Enterprise Server for SAP Applications 12 SP4 curl Released
SUSE Studio Onsite 1.3 curl Not affected